
-- Version according to Anton Scheffer

prompt
prompt
prompt Create trigger emp_ext_tab_vw_io

create or replace trigger emp_ext_tab_vw_io
instead of insert or update or delete on emp_ext_tab_vw
declare
  c_dir constant varchar2(256) := 'EXT_TABLES';
  c_org constant varchar2(256) := 'emp_ext_tab.csv';
  c_tmp constant varchar2(256) := 'emp_ext_tab_temp.csv';
  c_sep constant varchar2(1) := ',';
  fh_org utl_file.file_type;
  fh_tmp utl_file.file_type;
  line varchar2( 32767 );
  x pls_integer;
  r pls_integer;
begin
  if inserting
  then
    fh_org := utl_file.fopen( c_dir, c_org, 'a', 32767 );
    utl_file.put_line( fh_org
                     , to_char( :new.empno )                 || c_sep ||
                       :new.ename                            || c_sep ||
                       :new.job                              || c_sep ||
                       to_char( :new.mgr )                   || c_sep ||
                       to_char( :new.hiredate, 'dd-MON-rr' ) || c_sep ||
                       to_char( :new.sal )                   || c_sep ||
                       to_char( :new.comm )                  || c_sep ||
                       to_char( :new.deptno )
                     );
    utl_file.fclose( fh_org );
  else
    fh_org := utl_file.fopen( c_dir, c_org, 'r', 32767 );
    fh_tmp := utl_file.fopen( c_dir, c_tmp, 'w', 32767 );
    r := 0;
    x := :old.rownumber;
    loop
      begin
        utl_file.get_line( fh_org, line );
        r := r + 1;
        if r = x
        then
          if deleting
          then
            line := null;
          else
            line := to_char( :new.empno )                 || c_sep ||
                    :new.ename                            || c_sep ||
                    :new.job                              || c_sep ||
                    to_char( :new.mgr )                   || c_sep ||
                    to_char( :new.hiredate, 'dd-MON-rr' ) || c_sep ||
                    to_char( :new.sal )                   || c_sep ||
                    to_char( :new.comm )                  || c_sep ||
                    to_char( :new.deptno );
          end if;
        end if;
        utl_file.put_line( fh_tmp, line );
      exception
        when no_data_found then exit;
        when others        then raise;
      end;
    end loop;
    utl_file.fclose  ( fh_org );
    utl_file.fclose  ( fh_tmp );
    utl_file.fcopy   ( c_dir, c_tmp, c_dir, c_org );
    utl_file.fremove ( c_dir, c_tmp );
  end if;
exception
  when others
  then
    if utl_file.is_open ( fh_org ) then utl_file.fclose ( fh_org ); end if;
    if utl_file.is_open ( fh_tmp ) then utl_file.fclose ( fh_tmp ); end if;
    raise;
end;
/

show errors
